QGIS Application - Bug report #17244

New node tool snapping index out of sync for transaction groups (and triggers in the DB)

2017-10-04 10:50 AM - Regis Haubourg

Status: Open
Priority: High
Assignee:

Category: Editing

Affected QGIS version:3.4.2
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corruptsdata:

Regression?: Yes
Easy fix?: No
Resolution:

Copied to github as #: 25142

Description

Hi,
This is something that happened in the past | guess.

When playing with new node tool with database updating other features than the currently edited one,

the snapping index is quickly out of sync. It worked correctly in 2.18 (issue was in 2.16 1IRW)

See the video here: [[https://youtu.be/Miex5XarR3g]]

History

#1 - 2018-03-01 10:46 AM - Regis Haubourg
- Crashes QGIS or corrupts data changed from No to Yes

Still true and very blocking in fact

#2 - 2018-03-01 10:47 AM - Giovanni Manghi

- Affected QGIS version changed from master to 3.0.0

#3 - 2018-03-01 11:10 AM - Regis Haubourg

- File bug_17244.sql added

- File 17244 _node_index_broken.qgs added

- Affected QGIS version changed from 3.0.0 to master

Added minimal dataset and project to reproduce

database is named bug_17244 on localhost in the attached project file

#4 - 2018-03-01 11:22 AM - Regis Haubourg

Update video using the minimal database attached
[[https://youtu.be/zZDF9ZM7y6l]]

#5 - 2018-11-08 01:28 PM - Giovanni Manghi
- Status changed from Open to Feedback
Please try on QGIS 3.4.1, if the issue is still valid change the affected version, thanks.

#6 - 2018-11-21 08:26 AM - Burghardt Scholle

| can't confirm this bug in either 3.4.1 or QGIS Master (QGIS code revision 152b1b09ff). | have done my tests with my own data as well as with the data

from Regis.

#7 - 2018-12-12 01:39 PM - Hugo Mercier

The issue is still present in 3.4.2.

However, when the "data dependencies” are correctly declared on the table "pipe" (the table "pipe" may be modified by the view "vw_pipe"), it works
correctly.

But ... this does not fix the other way around: when a modification is made to the table, the view geometry is updated but QGIS does not know it. That would

require to declare circular data dependencies between layers, which has been forbidden initially, but should probably be loosen.

See https://share.oslandia.net/public/fe1af2

#8 - 2018-12-17 02:13 PM - Giovanni Manghi
- Status changed from Feedback to Open
- Affected QGIS version changed from master to 3.4.2

#9 - 2019-01-23 10:06 PM - Martin Dobias

Isn't this fixed by https://github.com/qgis/QGIS/pull/8851 now?

#10 - 2019-01-24 08:39 AM - Hugo Mercier

Nope, the PR only fixed another sync problem of cache found in vertextool ("cachedGeometry").

But that does not resolve the problem here which is: the relation between the table and the view must be known somehow by QGIS to properly maintain
caches. Declaring "data dependencies" between them works as a not-very-user-friendly workaround, and only in "one direction”, because circular

dependencies have been explicitly forbidden. A short term fix would be to allow for such circular dependencies.

IMHO a better fix would be to have an editing mode where no cache is used and get rid of these "data dependencies"

Files
bug_17244.sq| 1.36 KB 2018-03-01 Regis Haubourg
17244 _node_index_broken.qgs 22.8 KB 2018-03-01 Regis Haubourg
